]> git.sesse.net Git - ffmpeg/blob - tests/fate-run.sh
Merge commit 'a957e9379d11f2982d615f92c30580a57ea8bb40'
[ffmpeg] / tests / fate-run.sh
1 #! /bin/sh
2
3 export LC_ALL=C
4
5 base=$(dirname $0)
6 . "${base}/md5.sh"
7
8 base64=tests/base64
9
10 test="${1#fate-}"
11 target_samples=$2
12 target_exec=$3
13 target_path=$4
14 command=$5
15 cmp=${6:-diff}
16 ref=${7:-"${base}/ref/fate/${test}"}
17 fuzz=${8:-1}
18 threads=${9:-1}
19 thread_type=${10:-frame+slice}
20 cpuflags=${11:-all}
21 cmp_shift=${12:-0}
22 cmp_target=${13:-0}
23 size_tolerance=${14:-0}
24 cmp_unit=${15:-2}
25 gen=${16:-no}
26 hwaccel=${17:-none}
27 report_type=${18:-standard}
28 keep=${19:-0}
29
30 outdir="tests/data/fate"
31 outfile="${outdir}/${test}"
32 errfile="${outdir}/${test}.err"
33 cmpfile="${outdir}/${test}.diff"
34 repfile="${outdir}/${test}.rep"
35
36 target_path(){
37     test ${1} = ${1#/} && p=${target_path}/
38     echo ${p}${1}
39 }
40
41 # $1=value1, $2=value2, $3=threshold
42 # prints 0 if absolute difference between value1 and value2 is <= threshold
43 compare(){
44     awk "BEGIN { v = $1 - $2; printf ((v < 0 ? -v : v) > $3) }"
45 }
46
47 do_tiny_psnr(){
48     psnr=$(tests/tiny_psnr "$1" "$2" $cmp_unit $cmp_shift 0) || return 1
49     val=$(expr "$psnr" : ".*$3: *\([0-9.]*\)")
50     size1=$(expr "$psnr" : '.*bytes: *\([0-9]*\)')
51     size2=$(expr "$psnr" : '.*bytes:[ 0-9]*/ *\([0-9]*\)')
52     val_cmp=$(compare $val $cmp_target $fuzz)
53     size_cmp=$(compare $size1 $size2 $size_tolerance)
54     if [ "$val_cmp" != 0 ] || [ "$size_cmp" != 0 ]; then
55         echo "$psnr"
56         if [ "$val_cmp" != 0 ]; then
57             echo "$3: |$val - $cmp_target| >= $fuzz"
58         fi
59         if [ "$size_cmp" != 0 ]; then
60             echo "size: |$size1 - $size2| >= $size_tolerance"
61         fi
62         return 1
63     fi
64 }
65
66 oneoff(){
67     do_tiny_psnr "$1" "$2" MAXDIFF
68 }
69
70 stddev(){
71     do_tiny_psnr "$1" "$2" stddev
72 }
73
74 oneline(){
75     printf '%s\n' "$1" | diff -u -b - "$2"
76 }
77
78 run(){
79     test "${V:-0}" -gt 0 && echo "$target_exec" $target_path/"$@" >&3
80     $target_exec $target_path/"$@"
81 }
82
83 runecho(){
84     test "${V:-0}" -gt 0 && echo "$target_exec" $target_path/"$@" >&3
85     $target_exec $target_path/"$@" >&3
86 }
87
88 probefmt(){
89     run ffprobe${PROGSUF} -show_entries format=format_name -print_format default=nw=1:nk=1 -v 0 "$@"
90 }
91
92 probetags(){
93     run ffprobe${PROGSUF} -show_entries format_tags -v 0 "$@"
94 }
95
96 runlocal(){
97     test "${V:-0}" -gt 0 && echo ${base}/"$@" ${base} >&3
98     ${base}/"$@" ${base}
99 }
100
101 probeframes(){
102     run ffprobe${PROGSUF} -show_frames -v 0 "$@"
103 }
104
105 probechapters(){
106     run ffprobe${PROGSUF} -show_chapters -v 0 "$@"
107 }
108
109 probegaplessinfo(){
110     filename="$1"
111     shift
112     run ffprobe${PROGSUF} -bitexact -select_streams a -show_entries format=start_time,duration:stream=index,start_pts,duration_ts -v 0 "$filename" "$@"
113     pktfile1="${outdir}/${test}.pkts"
114     framefile1="${outdir}/${test}.frames"
115     cleanfiles="$cleanfiles $pktfile1 $framefile1"
116     run ffprobe${PROGSUF} -bitexact -select_streams a -of compact -count_packets -show_entries packet=pts,dts,duration,flags:stream=nb_read_packets -v 0 "$filename" "$@" > "$pktfile1"
117     head -n 8 "$pktfile1"
118     tail -n 9 "$pktfile1"
119     run ffprobe${PROGSUF} -bitexact -select_streams a -of compact -count_frames -show_entries frame=pkt_pts,pkt_dts,best_effort_timestamp,pkt_duration,nb_samples:stream=nb_read_frames -v 0 "$filename" "$@" > "$framefile1"
120     head -n 8 "$framefile1"
121     tail -n 9 "$framefile1"
122 }
123
124 ffmpeg(){
125     dec_opts="-hwaccel $hwaccel -threads $threads -thread_type $thread_type"
126     ffmpeg_args="-nostdin -nostats -cpuflags $cpuflags"
127     for arg in $@; do
128         [ x${arg} = x-i ] && ffmpeg_args="${ffmpeg_args} ${dec_opts}"
129         ffmpeg_args="${ffmpeg_args} ${arg}"
130     done
131     run ffmpeg${PROGSUF} ${ffmpeg_args}
132 }
133
134 framecrc(){
135     ffmpeg "$@" -bitexact -f framecrc -
136 }
137
138 ffmetadata(){
139     ffmpeg "$@" -bitexact -f ffmetadata -
140 }
141
142 framemd5(){
143     ffmpeg "$@" -bitexact -f framemd5 -
144 }
145
146 crc(){
147     ffmpeg "$@" -f crc -
148 }
149
150 md5pipe(){
151     ffmpeg "$@" md5:
152 }
153
154 md5(){
155     encfile="${outdir}/${test}.out"
156     cleanfiles="$cleanfiles $encfile"
157     ffmpeg "$@" $encfile
158     do_md5sum $encfile | awk '{print $1}'
159 }
160
161 pcm(){
162     ffmpeg "$@" -vn -f s16le -
163 }
164
165 fmtstdout(){
166     fmt=$1
167     shift 1
168     ffmpeg -bitexact "$@" -f $fmt -
169 }
170
171 enc_dec_pcm(){
172     out_fmt=$1
173     dec_fmt=$2
174     pcm_fmt=$3
175     src_file=$(target_path $4)
176     shift 4
177     encfile="${outdir}/${test}.${out_fmt}"
178     cleanfiles=$encfile
179     encfile=$(target_path ${encfile})
180     ffmpeg -i $src_file "$@" -f $out_fmt -y ${encfile} || return
181     ffmpeg -bitexact -i ${encfile} -c:a pcm_${pcm_fmt} -fflags +bitexact -f ${dec_fmt} -
182 }
183
184 FLAGS="-flags +bitexact -sws_flags +accurate_rnd+bitexact -fflags +bitexact"
185 DEC_OPTS="-threads $threads -idct simple $FLAGS"
186 ENC_OPTS="-threads 1        -idct simple -dct fastint"
187
188 enc_dec(){
189     src_fmt=$1
190     srcfile=$2
191     enc_fmt=$3
192     enc_opt=$4
193     dec_fmt=$5
194     dec_opt=$6
195     encfile="${outdir}/${test}.${enc_fmt}"
196     decfile="${outdir}/${test}.out.${dec_fmt}"
197     cleanfiles="$cleanfiles $decfile"
198     test "$7" = -keep || cleanfiles="$cleanfiles $encfile"
199     tsrcfile=$(target_path $srcfile)
200     tencfile=$(target_path $encfile)
201     tdecfile=$(target_path $decfile)
202     ffmpeg -f $src_fmt $DEC_OPTS -i $tsrcfile $ENC_OPTS $enc_opt $FLAGS \
203         -f $enc_fmt -y $tencfile || return
204     do_md5sum $encfile
205     echo $(wc -c $encfile)
206     ffmpeg $8 $DEC_OPTS -i $tencfile $ENC_OPTS $dec_opt $FLAGS \
207         -f $dec_fmt -y $tdecfile || return
208     do_md5sum $decfile
209     tests/tiny_psnr $srcfile $decfile $cmp_unit $cmp_shift
210 }
211
212 transcode(){
213     src_fmt=$1
214     srcfile=$2
215     enc_fmt=$3
216     enc_opt=$4
217     final_decode=$5
218     encfile="${outdir}/${test}.${enc_fmt}"
219     test "$7" = -keep || cleanfiles="$cleanfiles $encfile"
220     tsrcfile=$(target_path $srcfile)
221     tencfile=$(target_path $encfile)
222     ffmpeg -f $src_fmt $DEC_OPTS -i $tsrcfile $ENC_OPTS $enc_opt $FLAGS \
223         -f $enc_fmt -y $tencfile || return
224     do_md5sum $encfile
225     echo $(wc -c $encfile)
226     ffmpeg $DEC_OPTS -i $encfile $ENC_OPTS $FLAGS $final_decode \
227         -f framecrc - || return
228 }
229
230 stream_remux(){
231     src_fmt=$1
232     srcfile=$2
233     enc_fmt=$3
234     stream_maps=$4
235     final_decode=$5
236     encfile="${outdir}/${test}.${enc_fmt}"
237     test "$7" = -keep || cleanfiles="$cleanfiles $encfile"
238     tsrcfile=$(target_path $srcfile)
239     tencfile=$(target_path $encfile)
240     ffmpeg -f $src_fmt -i $tsrcfile $stream_maps -codec copy $FLAGS \
241         -f $enc_fmt -y $tencfile || return
242     ffmpeg $DEC_OPTS -i $encfile $ENC_OPTS $FLAGS $final_decode \
243         -f framecrc - || return
244 }
245
246 # FIXME: There is a certain duplication between the avconv-related helper
247 # functions above and below that should be refactored.
248 ffmpeg2="$target_exec ${target_path}/ffmpeg"
249 raw_src="${target_path}/tests/vsynth1/%02d.pgm"
250 pcm_src="${target_path}/tests/data/asynth1.sw"
251 crcfile="tests/data/$test.lavf.crc"
252 target_crcfile="${target_path}/$crcfile"
253
254 [ "${V-0}" -gt 0 ] && echov=echov || echov=:
255
256 echov(){
257     echo "$@" >&3
258 }
259
260 AVCONV_OPTS="-nostdin -nostats -y -cpuflags $cpuflags -threads $threads"
261 DEC_OPTS="-flags +bitexact -idct simple -sws_flags +accurate_rnd+bitexact -fflags +bitexact"
262 ENC_OPTS="$DEC_OPTS -threads $threads -dct fastint"
263
264 run_avconv(){
265     $echov $ffmpeg2 $AVCONV_OPTS $*
266     $ffmpeg2 $AVCONV_OPTS $*
267 }
268
269 do_avconv(){
270     f="$1"
271     shift
272     set -- $* ${target_path}/$f
273     run_avconv $*
274     do_md5sum $f
275     echo $(wc -c $f)
276 }
277
278 do_avconv_crc(){
279     f="$1"
280     shift
281     run_avconv $* -f crc "$target_crcfile"
282     echo "$f $(cat $crcfile)"
283 }
284
285 lavf_audio(){
286     t="${test#lavf-}"
287     outdir="tests/data/lavf"
288     file=${outdir}/lavf.$t
289     do_avconv $file $DEC_OPTS $1 -ar 44100 -f s16le -i $pcm_src "$ENC_OPTS -metadata title=lavftest" -t 1 -qscale 10 $2
290     do_avconv_crc $file $DEC_OPTS $3 -i $target_path/$file
291 }
292
293 lavf_image(){
294     t="${test#lavf-}"
295     outdir="tests/data/images/$t"
296     mkdir -p "$outdir"
297     file=${outdir}/%02d.$t
298     run_avconv $DEC_OPTS $1 -f image2 -c:v pgmyuv -i $raw_src "$ENC_OPTS -metadata title=lavftest" $2 -frames 13 -y -qscale 10 $target_path/$file
299     do_md5sum ${outdir}/02.$t
300     do_avconv_crc $file $DEC_OPTS $2 -i $target_path/$file
301     echo $(wc -c ${outdir}/02.$t)
302 }
303
304 lavf_image2pipe(){
305     t="${test#lavf-}"
306     t="${t%pipe}"
307     outdir="tests/data/lavf"
308     file=${outdir}/${t}pipe.$t
309     do_avconv $file $DEC_OPTS -f image2 -c:v pgmyuv -i $raw_src -f image2pipe "$ENC_OPTS -metadata title=lavftest" -t 1 -qscale 10
310     do_avconv_crc $file $DEC_OPTS -f image2pipe -i $target_path/$file
311 }
312
313 lavffatetest(){
314     t="${test#lavf-fate-}"
315     ref=${base}/ref/lavf-fate/$t
316     ${base}/lavf-regression.sh $t lavf-fate tests/vsynth1 "$target_exec" "$target_path" "$threads" "$thread_type" "$cpuflags" "$target_samples"
317 }
318
319 lavftest(){
320     t="${test#lavf-}"
321     ref=${base}/ref/lavf/$t
322     ${base}/lavf-regression.sh $t lavf tests/vsynth1 "$target_exec" "$target_path" "$threads" "$thread_type" "$cpuflags" "$target_samples"
323 }
324
325 refcmp_metadata(){
326     refcmp=$1
327     pixfmt=$2
328     fuzz=${3:-0.001}
329     ffmpeg $FLAGS $ENC_OPTS \
330         -lavfi "testsrc2=size=300x200:rate=1:duration=5,format=${pixfmt},split[ref][tmp];[tmp]avgblur=4[enc];[enc][ref]${refcmp},metadata=print:file=-" \
331         -f null /dev/null | awk -v ref=${ref} -v fuzz=${fuzz} -f ${base}/refcmp-metadata.awk -
332 }
333
334 video_filter(){
335     filters=$1
336     shift
337     label=${test#filter-}
338     raw_src="${target_path}/tests/vsynth1/%02d.pgm"
339     printf '%-20s' $label
340     ffmpeg $DEC_OPTS -f image2 -vcodec pgmyuv -i $raw_src \
341         $FLAGS $ENC_OPTS -vf "$filters" -vcodec rawvideo -frames:v 5 $* -f nut md5:
342 }
343
344 pixfmts(){
345     filter=${test#filter-pixfmts-}
346     filter=${filter%_*}
347     filter_args=$1
348     prefilter_chain=$2
349     nframes=${3:-1}
350
351     showfiltfmts="$target_exec $target_path/libavfilter/tests/filtfmts"
352     scale_exclude_fmts=${outfile}_scale_exclude_fmts
353     scale_in_fmts=${outfile}_scale_in_fmts
354     scale_out_fmts=${outfile}_scale_out_fmts
355     in_fmts=${outfile}_in_fmts
356
357     # exclude pixel formats which are not supported as input
358     $showfiltfmts scale | awk -F '[ \r]' '/^INPUT/{ fmt=substr($3, 5); print fmt }' | sort >$scale_in_fmts
359     $showfiltfmts scale | awk -F '[ \r]' '/^OUTPUT/{ fmt=substr($3, 5); print fmt }' | sort >$scale_out_fmts
360     comm -12 $scale_in_fmts $scale_out_fmts >$scale_exclude_fmts
361
362     $showfiltfmts $filter | awk -F '[ \r]' '/^INPUT/{ fmt=substr($3, 5); print fmt }' | sort >$in_fmts
363     pix_fmts=$(comm -12 $scale_exclude_fmts $in_fmts)
364
365     outertest=$test
366     for pix_fmt in $pix_fmts; do
367         test=$pix_fmt
368         video_filter "${prefilter_chain}format=$pix_fmt,$filter=$filter_args" -pix_fmt $pix_fmt -frames:v $nframes
369     done
370
371     rm $in_fmts $scale_in_fmts $scale_out_fmts $scale_exclude_fmts
372     test=$outertest
373 }
374
375 gapless(){
376     sample=$(target_path $1)
377     extra_args=$2
378
379     decfile1="${outdir}/${test}.out-1"
380     decfile2="${outdir}/${test}.out-2"
381     decfile3="${outdir}/${test}.out-3"
382     cleanfiles="$cleanfiles $decfile1 $decfile2 $decfile3"
383
384     # test packet data
385     ffmpeg $extra_args -i "$sample" -bitexact -c:a copy -f framecrc -y $decfile1
386     do_md5sum $decfile1
387     # test decoded (and cut) data
388     ffmpeg $extra_args -i "$sample" -bitexact -f wav md5:
389     # the same as above again, with seeking to the start
390     ffmpeg $extra_args -ss 0 -seek_timestamp 1 -i "$sample" -bitexact -c:a copy -f framecrc -y $decfile2
391     do_md5sum $decfile2
392     ffmpeg $extra_args -ss 0 -seek_timestamp 1 -i "$sample" -bitexact -f wav md5:
393     # test packet data, with seeking to a specific position
394     ffmpeg $extra_args -ss 5 -seek_timestamp 1 -i "$sample" -bitexact -c:a copy -f framecrc -y $decfile3
395     do_md5sum $decfile3
396 }
397
398 gaplessenc(){
399     sample=$(target_path $1)
400     format=$2
401     codec=$3
402
403     file1="${outdir}/${test}.out-1"
404     cleanfiles="$cleanfiles $file1"
405
406     # test data after reencoding
407     ffmpeg -i "$sample" -bitexact -map 0:a -c:a $codec -f $format -y "$file1"
408     probegaplessinfo "$file1"
409 }
410
411 audio_match(){
412     sample=$(target_path $1)
413     trefile=$(target_path $2)
414     extra_args=$3
415
416     decfile="${outdir}/${test}.wav"
417     cleanfiles="$cleanfiles $decfile"
418
419     ffmpeg -i "$sample" -bitexact $extra_args -y $decfile
420     tests/audiomatch $decfile $trefile
421 }
422
423 concat(){
424     template=$1
425     sample=$2
426     mode=$3
427     extra_args=$4
428
429     concatfile="${outdir}/${test}.ffconcat"
430     packetfile="${outdir}/${test}.ffprobe"
431     cleanfiles="$concatfile $packetfile"
432
433     awk "{gsub(/%SRCFILE%/, \"$sample\"); print}" $template > $concatfile
434
435     if [ "$mode" = "md5" ]; then
436         run ffprobe${PROGSUF} -bitexact -show_streams -show_packets -v 0 -fflags keepside -safe 0 $extra_args $concatfile | tr -d '\r' > $packetfile
437         do_md5sum $packetfile
438     else
439         run ffprobe${PROGSUF} -bitexact -show_streams -show_packets -v 0 -of compact=p=0:nk=1 -fflags keepside -safe 0 $extra_args $concatfile
440     fi
441 }
442
443 null(){
444     :
445 }
446
447 # Disable globbing: command arguments may contain globbing characters and
448 # must be kept verbatim
449 set -f
450
451 exec 3>&2
452 eval $command >"$outfile" 2>$errfile
453 err=$?
454
455 if [ $err -gt 128 ]; then
456     sig=$(kill -l $err 2>/dev/null)
457     test "${sig}" = "${sig%[!A-Za-z]*}" || unset sig
458 fi
459
460 if test -e "$ref" || test $cmp = "oneline" || test $cmp = "null" || test $cmp = "grep" ; then
461     case $cmp in
462         diff)   diff -u -b "$ref" "$outfile"            >$cmpfile ;;
463         rawdiff)diff -u    "$ref" "$outfile"            >$cmpfile ;;
464         oneoff) oneoff     "$ref" "$outfile"            >$cmpfile ;;
465         stddev) stddev     "$ref" "$outfile"            >$cmpfile ;;
466         oneline)oneline    "$ref" "$outfile"            >$cmpfile ;;
467         grep)   grep       "$ref" "$errfile"            >$cmpfile ;;
468         null)   cat               "$outfile"            >$cmpfile ;;
469     esac
470     cmperr=$?
471     test $err = 0 && err=$cmperr
472     if [ "$report_type" = "ignore" ]; then
473         test $err = 0 || echo "IGNORE\t${test}" && err=0 && unset sig
474     else
475         test $err = 0 || cat $cmpfile
476     fi
477 else
478     echo "reference file '$ref' not found"
479     err=1
480 fi
481
482 if [ $err -eq 0 ] && test $report_type = "standard" ; then
483     unset cmpo erro
484 else
485     cmpo="$($base64 <$cmpfile)"
486     erro="$($base64 <$errfile)"
487 fi
488 echo "${test}:${sig:-$err}:$cmpo:$erro" >$repfile
489
490 if test $err != 0 && test $gen != "no" ; then
491     echo "GEN     $ref"
492     cp -f "$outfile" "$ref"
493     err=$?
494 fi
495
496 if test $err = 0; then
497     if test $keep = 0; then
498         rm -f $outfile $errfile $cmpfile $cleanfiles
499     fi
500 elif test $gen = "no"; then
501     echo "Test $test failed. Look at $errfile for details."
502     test "${V:-0}" -gt 0 && cat $errfile
503 else
504     echo "Updating reference failed, possibly no output file was generated."
505 fi
506 exit $err